searchNodes=[{"doc":"ChromicPDF is a fast HTML-to-PDF/A renderer based on Chrome &amp; Ghostscript. Usage Boot Start ChromicPDF as part of your supervision tree: def MyApp.Application do def start(_type, _args) do children = [ # other apps... {ChromicPDF, chromic_pdf_opts()} ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end defp chromic_pdf_opts do [] end end Print a PDF / PDF/A Please see ChromicPDF.print_to_pdf/2 and ChromicPDF.convert_to_pdfa/2. Options ChromicPDF spawns two worker pools, the session pool and the ghostscript pool. By default, it will create 5 workers with no overflow. To change these options, you may pass configuration to the supervisor. Please see https://github.com/devinus/poolboy for available options. defp chromic_pdf_opts do [ session_pool: [ size: 3, max_overflow: 0 ], ghostscript_pool: [ size: 10, max_overflow: 2 ] ] end Please note, that these are only worker pools. If you intend to max them out, you will need a job queue as well. Security Chrome Sandbox By default, ChromicPDF will run Chrome in sandbox mode. If you absolutely must run Chrome as root, you can turn of its sandbox by passing the no_sandbox: true option. defp chromic_pdf_opts do [no_sandbox: true] end Running in online mode Browser targets spawned by ChromicPDF will be set to &quot;offline&quot; mode using the DevTools&#39; emulateNetworkConditions command. This is intentional. Users are required to take an extra step (basically reading this paragraph) to re-consider whether basing their application&#39;s PDF printing on remote URL requests. Both because it can lead to unexpected performance fluctuation, as well as because it might increase the attack surface of their app. To switch on &quot;online&quot; mode, pass the offline: false parameter. defp chromic_pdf_opts do [offline: true] end How it works PDF Printing ChromicPDF spawns an instance of Chromium/Chrome (an OS process) and connects to its &quot;DevTools&quot; channel via file descriptors. The Chrome process is supervised and the connected processes will automatically recover if it crashes. A number of &quot;targets&quot; in Chrome are spawned, 1 per worker process in the SessionPool. By default, ChromicPDF will spawn each session in a new browser context (i.e., a profile). When a PDF print is requested, a session will instruct its assigned &quot;target&quot; to navigate to the given URL, then wait until it receives a &quot;frameStoppedLoading&quot; event, and proceed to call the printToPDF function. The printed PDF will be sent to the session as Base64 encoded chunks.","ref":"ChromicPDF.html","title":"ChromicPDF","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"ChromicPDF.html#child_spec/1","title":"ChromicPDF.child_spec/1","type":"function"},{"doc":"Converts a PDF to PDF/A (either PDF/A-2b or PDF/A-3b). Convert an input PDF and return a Base64-encoded blob {:ok, blob} = ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;) Convert and write to file ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, output: &quot;output.pdf&quot;) PDF/A versions &amp; levels Ghostscript supports both PDF/A-2 and PDF/A-3 versions, both in their b (basic) level. By default, ChromicPDF generates version PDF/A-3b files. Set the pdfa_version option for version 2. ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, pdfa_version: &quot;2&quot;) Specifying PDF metadata The converter is able to transfer PDF metadata (the Info dictionary) from the original PDF file to the output file. However, files printed by Chrome do not contain any metadata information (except &quot;Creator&quot; being &quot;Chrome&quot;). The :info option of the PDF/A converter allows to specify metatadata for the output file directly. ChromicPDF.convert_to_pdfa(&quot;some_pdf_file.pdf&quot;, info: %{creator: &quot;ChromicPDF&quot;}) The converter understands the following keys, all of which accept only String values: :title :author :subject :keywords :creator :creation_date :mod_date By specification, date values in :creation_date and :mod_date do not need to follow a specific syntax. However, Ghostscript inserts date strings like &quot;D:20200208153049+00&#39;00&#39;&quot; and Info extractor tools might rely on this or another specific format. The converter will automatically format given DateTime values like this. Both :creation_date and :mod_date are filled with the current date automatically (by Ghostscript), if the original file did not contain any. Adding more PostScript to the conversion The pdfa_def_ext option can be used to feed more PostScript code into the final conversion step. This can be useful to add additional features to the generated PDF-A file, for instance a ZUGFeRD invoice. ChromicPDF.convert_to_pdfa( &quot;some_pdf_file.pdf&quot;, pdfa_def_ext: &quot;[/Title (OverriddenTitle) /DOCINFO pdfmark&quot;, )","ref":"ChromicPDF.html#convert_to_pdfa/2","title":"ChromicPDF.convert_to_pdfa/2","type":"function"},{"doc":"Prints a PDF. This call blocks until the PDF has been created. Print and return Base64-encoded PDF {:ok, blob} = ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}) Print to file ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: &quot;output.pdf&quot;) Print to temporary file ChromicPDF.print_to_pdf({:url, &quot;file:///example.html&quot;}, output: fn output_pdf -&gt; send_download(...) end) The temporary file passed to the callback will be deleted when the callback returns. PDF printing options ChromicPDF.print_to_pdf( {:url, &quot;file:///example.html&quot;}, print_to_pdf: %{ marginTop: 0.787402, marginLeft: 0.787402, marginRight: 0.787402, marginBottom: 0.787402, } ) For a full list of options to the printToPDF function, please see the Chrome documentation at: https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDF Print from in-memory HTML For convenience, it is also possible to pass a HTML blob to print_to_pdf/2 which is automatically stored in a temporary file and cleaned up afterwards. It is served over the file:// scheme. ChromicPDF.print_to_pdf( {:html, &quot;&lt;html&gt;&lt;body&gt;&lt;h1&gt;Hello World!&lt;/h1&gt;&lt;/body&gt;&lt;/html&gt;&quot;} )","ref":"ChromicPDF.html#print_to_pdf/2","title":"ChromicPDF.print_to_pdf/2","type":"function"},{"doc":"Prints a PDF and converts it to PDF/A in a single call. See print_to_pdf/2 and convert_to_pdfa/2 for options. Example ChromicPDF.print_to_pdfa({:url, &quot;https://example.net&quot;})","ref":"ChromicPDF.html#print_to_pdfa/2","title":"ChromicPDF.print_to_pdfa/2","type":"function"},{"doc":"","ref":"ChromicPDF.html#start_link/1","title":"ChromicPDF.start_link/1","type":"function"},{"doc":"Use this for multiple ChromicPDF instances. When is this useful? You want to completely separate two or more PDF &quot;queues&quot; You want to give your PDF module a custom API Usage defmodule MyApp.MyPDFGenerator do use ChromicPDF.Supervisor end def MyApp.Application do def start(_type, _args) do children = [ MyApp.MyPDFGenerator ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"ChromicPDF.Supervisor.html","title":"ChromicPDF.Supervisor","type":"module"},{"doc":"ChromicPDF ChromicPDF is a small wrapper around Chrome&#39;s printToPDF API that allows to print a URL to PDF.","ref":"readme.html","title":"ChromicPDF","type":"extras"},{"doc":"Node-free: In contrast to many other packages, it does not use puppeteer, and hence does not require Node.js. It communicates directly with Chrome&#39;s DevTools API over pipes, offering the same performance as puppeteer, if not better. Header/Footer: Using the DevTools API allows to apply the full set of options of the printToPDF function. Most notably, it supports header and footer HTML templates. PDF/A: It can convert printed files to PDF/A using Ghostscript, inspired by the pdf2archive script originally created by @matteosecli and later enhanced by @JaimeChavarriaga. Created PDF/A-2b and PDF/A-3b files pass the verapdf compliance checks.","ref":"readme.html#features","title":"ChromicPDF - Features","type":"extras"},{"doc":"Chromium or Chrome Ghostscript (for PDF/A support)","ref":"readme.html#requirements","title":"ChromicPDF - Requirements","type":"extras"},{"doc":"ChromicPDF is a supervision tree (rather than an application). You will need to inject it into the supervision tree of your application. First, add ChromicPDF to your runtime dependencies: def deps do [ {:chromic_pdf, &quot;~&gt; 0.1.0&quot;} ] end Next, start ChromicPDF as part of your application: # lib/my_app/application.ex def MyApp.Application do def start(_type, _args) do children = [ # other apps... ChromicPDF ] Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor) end end","ref":"readme.html#installation","title":"ChromicPDF - Installation","type":"extras"},{"doc":"Example ChromicPDF.print_to_pdfa( # URL to of local file to print {:url, &quot;file:///example.html&quot;}, # Parameters to the PDF renderer, specifically for Chromium&#39;s printToPDF function, # see https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDF print_to_pdf: %{ # Margins are in given inches marginTop: 0.393701, marginLeft: 0.787402, marginRight: 0.787402, marginBottom: 1.1811, # Print header and footer (on each page). # This will print the default templates if none are given. displayHeaderFooter: true, # Even on empty string. # To disable header or footer, pass an empty element. headerTemplate: &quot;&lt;span&gt;&lt;/span&gt;&quot;, # Example footer template. # They are completely unstyled by default and have a font-size of zero, # so don&#39;t despair if they don&#39;t show up at first. # There&#39;s a lot of documentation online about how to style them properly, # this is just a basic example. The &lt;span&gt; classes shown below are # interpolated by Chrome, see the printToPDF documentation. footerTemplate: &quot;&quot;&quot; &lt;style&gt; p { color: #333; font-size: 10pt; text-align: right; margin: 0 0.787402in; width: 100%; z-index: 1000; } &lt;/style&gt; &lt;p&gt; Page &lt;span class=&quot;pageNumber&quot;&gt;&lt;/span&gt; of &lt;span class=&quot;totalPages&quot;&gt;&lt;/span&gt; &lt;/p&gt; &quot;&quot;&quot; }, # Parameters for the PDF/A converter info: %{ title: &quot;Example&quot;, author: &quot;Jane Doe&quot;, creator: &quot;ChromicPDF&quot; }, pdfa_version: &quot;3&quot; # Output path. output: &quot;test.pdf&quot; )","ref":"readme.html#usage","title":"ChromicPDF - Usage","type":"extras"},{"doc":"For running the full suite of integration tests, please install and have in your $PATH: verapdf For pdfinfo and pdftotext, you need poppler-utils (most Linux distributions) or Xpdf (OSX) For the odd ZUGFeRD test in pdfa_generation_test.exs, you need to download ZUV and set the $ZUV_JAR environment variable.","ref":"readme.html#development","title":"ChromicPDF - Development","type":"extras"}]